#include <Wire.h>
int I2C_Salve_Addr=0x48;
char Ping()
{
  Wire.beginTransmission(I2C_Salve_Addr);
  Wire.write(0xaa);
  Wire.endTransmission(0);
  Wire.requestFrom(I2C_Salve_Addr, 1, 1);
  unsigned char device = Wire.read();
  if(device==0x66){Serial.println("发现设备");
    return 0;
  }
  else {
    Serial.println("没有发现设备");
    return 1; 
  }
}
void Error()
{
  Wire.beginTransmission(I2C_Salve_Addr);
  Wire.write(0xde);
  Wire.endTransmission(0);
  Wire.requestFrom(I2C_Salve_Addr, 1, 1);
  unsigned char error = Wire.read();
  if(!error){Serial.println("没有错误");
  }
  else {
    if(error&0b00010000)Serial.println("R过曝"); 
    if(error&0b00001000)Serial.println("G过曝"); 
    if(error&0b00000100)Serial.println("B过曝"); 
    if(error&0b00000010)Serial.println("按键短路"); 
    if(error&0b00000001)Serial.println("对管过曝"); 
  }
  // Serial.println();
}
void Soft_reset()
{
  Serial.println("软件复位"); 
  Wire.beginTransmission(I2C_Salve_Addr);
  Wire.write(0xc0);
  Wire.endTransmission();
}
void Get_Version()
{
  Serial.print("当前版本V");
  char version_h, version_l;
  Wire.beginTransmission(I2C_Salve_Addr); 		
  Wire.write(0xc1);        		
  Wire.endTransmission();    		
  Wire.requestFrom(I2C_Salve_Addr, 1, 1);    
  unsigned char version =Wire.read();
  version_l = version & 0x0F;
  version_h = (version >> 4) & 0x0F;
  Serial.print(version_h,DEC);
  Serial.print(".");
  Serial.print(version_l,DEC);
  Serial.println();
}
void change_IIC_Address(unsigned char address) 
{
  Serial.print("更改地址：");
  Serial.println(address,HEX);
  Wire.beginTransmission(I2C_Salve_Addr);
  Wire.write(0xAD);
  Wire.write(0xAD);
  Wire.write(address);
  Wire.endTransmission();
}
void Generalcall_readdress()  //广播重置软件地址
{
  Serial.println("广播");
  unsigned char readdress[8] = { 0xB8, 0xD0, 0xCE, 0xAA, 0xBF, 0xC6, 0xBC, 0xBC };
  Wire.beginTransmission(0x00);
  Wire.write(readdress, 8);
  Wire.endTransmission();
}
void Read_RGB()
{
  Serial.print("RGB: ");
  Wire.beginTransmission(I2C_Salve_Addr);
  Wire.write(0xD0);
  Wire.endTransmission(1);
  Wire.requestFrom(I2C_Salve_Addr, 3, 1);
  for(int i=0;i<3;i++)
  {
      unsigned char data = Wire.read();
      Serial.print(data,DEC);
      Serial.print("  ");
  }
  Serial.println();
}
void Read_HSL()
{
  Serial.print("HSL: ");
  Wire.beginTransmission(I2C_Salve_Addr);
  Wire.write(0xD1);
  Wire.endTransmission(1);
  Wire.requestFrom(I2C_Salve_Addr, 3, 1);
  for(int i=0;i<3;i++)
  {
      unsigned char data = Wire.read();
      Serial.print(data,DEC);
      Serial.print("  ");
  }
  Serial.println();
}
void iic_scaner()
{
    int nDevices = 0;
    for (byte address = 1; address < 127; ++address) {
    Wire.beginTransmission(address);
    byte error = Wire.endTransmission();

    if (error == 0) {
      Serial.print("I2C 设备地址在 0x");
      if (address < 16) {
        Serial.print("0");
      }
      Serial.print(address, HEX);
      Serial.println("  !");
      ++nDevices;
      break;
    } else if (error == 4) {
      Serial.print("错误地址 0x");
      if (address < 16) {
        Serial.print("0");
      }
      Serial.println(address, HEX);
    }
  }
}
void setup() 
{
  Wire.begin();
  Wire.setClock(100000);
  Serial.begin(115200);  
  Generalcall_readdress();
  Soft_reset();
  while(Ping());
  Get_Version();
}
void task()
{
  while(Ping());
  Get_Version();
  Error();
  // iic_scaner();
  // change_IIC_Address(0xff);
  // Soft_reset();
  // delay(1000);
  // iic_scaner();
  // Generalcall_readdress();
  // Soft_reset();
  // delay(1000);
  // iic_scaner();
  Read_HSL();
  Read_RGB();
  
}
void loop() {
  task();
  delay(1000);
}
